// *****************************************************************
// ****                      Synth CORE B                       ****
// ****                  www.tolaemon.com/scoreb                ****
// ****                       Source code                       ****
// ****                       13/11/2011                        ****
// ****                     Jordi Bartolome                     ****
// ****                                                         ****
// **** IMPORTANT:                                              ****
// **** Using parts of this code means accepting all conditions ****
// **** exposed on the web: www.tolaemon.com/scoreb             ****
// ****                                                         ****
// **** Parts of this code have been taken from the demo source ****
// **** code of EVK1100 Atmel's evaluation board				****
// *****************************************************************

/* Copyright (C) 2006-2008, Atmel Corporation All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 *
 * 3. The name of ATMEL may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY ATMEL ``AS IS'' AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE EXPRESSLY AND
 * SPECIFICALLY DISCLAIMED. IN NO EVENT SHALL ATMEL BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
	FreeRTOS.org V4.7.2 - Copyright (C) 2003-2008 Richard Barry.

	This file is part of the FreeRTOS.org distribution.

	FreeRTOS.org is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	FreeRTOS.org is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with FreeRTOS.org; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	A special exception to the GPL can be applied should you wish to distribute
	a combined work that includes FreeRTOS.org, without being obliged to provide
	the source code for any proprietary components.  See the licensing section
	of http://www.FreeRTOS.org for full details of how and when the exception
	can be applied.

	***************************************************************************

	Please ensure to read the configuration and relevant port sections of the
	online documentation.

	+++ http://www.FreeRTOS.org +++
	Documentation, latest information, license and contact details.

	+++ http://www.SafeRTOS.com +++
	A version that is certified for use in safety critical systems.

	+++ http://www.OpenRTOS.com +++
	Commercial support, development, porting, licensing and training services.

	***************************************************************************
*/

#ifndef SCOREB_DEFINES_H
#define SCOREB_DEFINES_H

// boolean defines
#define TRUE 	1
#define FALSE 	0

#define MAX_STRING 256

// device type definition
#define DEVICE_TYPE_COM 		0
#define DEVICE_TYPE_FILE 		1

// predefined task priorities
#define TASK_PRIORITY_1     ( tskIDLE_PRIORITY + 1 )
#define TASK_PRIORITY_2     ( tskIDLE_PRIORITY + 2 )
#define TASK_PRIORITY_3     ( tskIDLE_PRIORITY + 3 )
#define TASK_PRIORITY_4   	( tskIDLE_PRIORITY + 4 )
#define TASK_PRIORITY_5		( tskIDLE_PRIORITY + 5 )

// different modules tasks priorites
#define MIDI_TASK_PRIORITY 		TASK_PRIORITY_3
#define CONSOLE_TASK_PRIORITY 	TASK_PRIORITY_3
#define ADC_TASK_PRIORITY		TASK_PRIORITY_3

// interrupt pirorities
// From the datasheet:
// The Prioritizer hardware uses the ValReq lines and the INTLEVEL field in the IPRs to select the
// pending interrupt of the highest priority. If a NMI interrupt is pending, it automatically gets high-
// est priority of any pending interrupt. If several interrupt groups of the highest pending interrupt
// level have pending interrupts, the interrupt group with the highest number is selected.
#define RTC_CLOCK_INTERRUPT_LEVEL		 AVR32_INTC_INT2
#define COM_SERIAL_232_INTERRUPT_LEVEL 	 AVR32_INTC_INT1
#define COM_SERIAL_USB_INTERRUPT_LEVEL 	 AVR32_INTC_INT1
#define COM_SERIAL_MIDI_INTERRUPT_LEVEL  AVR32_INTC_INT1

// size of the stack in different tasks
#define CONSOLE_TASK_STACK_SIZE 1280
#define MIDI_TASK_STACK_SIZE 	configMINIMAL_STACK_SIZE
#define ADC_TASK_STACK_SIZE 	configMINIMAL_STACK_SIZE

#endif // SCOREB_DEFINES_H
