// *****************************************************************
// ****                      Synth CORE B                       ****
// ****                  www.tolaemon.com/scoreb                ****
// ****                       Source code                       ****
// ****                       13/11/2011                        ****
// ****                     Jordi Bartolome                     ****
// ****                                                         ****
// **** IMPORTANT:                                              ****
// **** Using parts of this code means accepting all conditions ****
// **** exposed on the web: www.tolaemon.com/scoreb             ****
// ****                                                         ****
// **** Parts of this code have been taken from the demo source ****
// **** code of EVK1100 Atmel's evaluation board				****
// *****************************************************************

// ansi c and atmel drivers includes
#include <avr32/io.h>
#include <stdlib.h>
#include <string.h>
#include "board.h"
#include "gpio.h"
#include "spi.h"
#include "navigation.h"
#include "fat.h"
#include "file.h"
#include "ctrl_access.h"
#include "sd_mmc_spi.h"


// scheduler includes.
#include "FreeRTOS.h"
#include "queue.h"
#include "task.h"

// synth core B includes
#include "defines.h"
#include "adc_converters.h"
#include "file_system.h"



// Synth Core  23-11-2011  Tolaemon
// Function: void FILE_SYS_SD_MMC_resources_init()
// Function which prepares the SPI to be used with
// the MMC_SD card
// Receives:
// Returns:
// Note:
//     Call before starting the OS scheduler
void FILE_SYS_SD_MMC_resources_init(void)
{

	// GPIO map for SPI.
  static const gpio_map_t SD_SPI_GPIO_MAP =
  {
    { SD_MMC_SPI_SCK_PIN, SD_MMC_SPI_SCK_FUNCTION },  // SPI Clock.
    { SD_MMC_SPI_MISO_PIN, SD_MMC_SPI_MISO_FUNCTION },// MISO.
    { SD_MMC_SPI_MOSI_PIN, SD_MMC_SPI_MOSI_FUNCTION}, // MOSI.
    { SD_MMC_SPI_NPCS_PIN, SD_MMC_SPI_NPCS_FUNCTION } // Chip Select NPCS.
  };

  // Options for SPI.
  spi_options_t spiOptions =
  {
    .reg          = SD_MMC_SPI_NPCS,
    .baudrate     = 1200000,//SD_MMC_SPI_MASTER_SPEED,
    .bits         = 8,
    .spck_delay   = 0,
    .trans_delay  = 0,
    .stay_act     = 1,
    .spi_mode     = 0,
    .modfdis      = 1
  };

  // Assign I/Os to SPI.
  gpio_enable_module(SD_SPI_GPIO_MAP,
                     sizeof(SD_SPI_GPIO_MAP) / sizeof(SD_SPI_GPIO_MAP[0]));

  // Initialize as master.
  spi_initMaster(SD_MMC_SPI, &spiOptions);

  // Set selection mode: variable_ps, pcs_decode, delay.
  spi_selectionMode(SD_MMC_SPI, 0, 0, 0);

  // Enable SPI.
  spi_enable(SD_MMC_SPI);

  sd_mmc_spi_init(spiOptions,FOSC0);

}//SD_MMC_resources_init
