// *****************************************************************
// ****                      Synth CORE B                       ****
// ****                  www.tolaemon.com/scoreb                ****
// ****                       Source code                       ****
// ****                       13/11/2011                        ****
// ****                     Jordi Bartolome                     ****
// ****                                                         ****
// **** IMPORTANT:                                              ****
// **** Using parts of this code means accepting all conditions ****
// **** exposed on the web: www.tolaemon.com/scoreb             ****
// ****                                                         ****
// **** Parts of this code have been taken from the demo source ****
// **** code of EVK1100 Atmel's evaluation board				****
// *****************************************************************

/* Copyright (C) 2006-2008, Atmel Corporation All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 *
 * 3. The name of ATMEL may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY ATMEL ``AS IS'' AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE EXPRESSLY AND
 * SPECIFICALLY DISCLAIMED. IN NO EVENT SHALL ATMEL BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
	FreeRTOS.org V4.7.2 - Copyright (C) 2003-2008 Richard Barry.

	This file is part of the FreeRTOS.org distribution.

	FreeRTOS.org is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	FreeRTOS.org is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with FreeRTOS.org; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	A special exception to the GPL can be applied should you wish to distribute
	a combined work that includes FreeRTOS.org, without being obliged to provide
	the source code for any proprietary components.  See the licensing section
	of http://www.FreeRTOS.org for full details of how and when the exception
	can be applied.

	***************************************************************************

	Please ensure to read the configuration and relevant port sections of the
	online documentation.

	+++ http://www.FreeRTOS.org +++
	Documentation, latest information, license and contact details.

	+++ http://www.SafeRTOS.com +++
	A version that is certified for use in safety critical systems.

	+++ http://www.OpenRTOS.com +++
	Commercial support, development, porting, licensing and training services.

	***************************************************************************
*/

#ifndef SCOREB_LCD_HD44780_H
#define SCOREB_LCD_HD44780_H

#include "gpio_ports.h"

//LCD CONNNECTOR 2 x 13:
//---------------------
// 01 GND
// 02 VCC_LCD
// 03 CONTRAST
// 04 BUS_IO_1 ..............PB21 ( pin 5 )
// 05 BUS_IO_2 ..............PB22 ( pin 6 )
// 06 BUS_IO_3 ..............PB23 ( pin 9 )
// 07 BUS_IO_4 ..............PB24 ( pin 11 )
// 08 BUS_IO_5 ..............PB25 ( pin 13 )
// 09 BUS_IO_6 ..............PB26 ( pin 14 )
// 10 BUS_IO_7 ..............PB27 ( pin 15 )
// 11 BUS_IO_8 ..............PB28 ( pin 19 )
// 12 BUS_IO_9 ..............PB31 ( pin 22 )
// 13 BUS_IO_10..............PA02 ( pin 30 )
// 14 BUS_IO_11 .............PA04 ( pin 34 )
// 15 VCC_CD
// 16 BACKLIGHT
// 17 BUS_IO_12..............PX12 ( pin 42 )
// 18 BUS_IO_13..............PA07 ( pin 43 )
// 19 BUS_IO_14..............PX13 ( pin 44 )
// 20 BUS_IO_15..............PX15 ( pin 59 )
// 21 VCC 5
// 22 VCC 5
// 23 VCC 3
// 24 VCC 3
// 25 GND
// 26 GND

//LCD CONNNECTOR FOR HD44780
//---------------------------
// 01 GND
// 02 VCC_LCD
// 03 CONTRAST
// 04 BUS_IO_1 ..............PB21 ( pin 5 ) RS REGISTER SELECT
// 05 BUS_IO_2 ..............PB22 ( pin 6 ) R/!W READ WRITE
// 06 BUS_IO_3 ..............PB23 ( pin 9 ) E ENABLE
// 07 BUS_IO_4 ..............PB24 ( pin 11 ) DATA 0
// 08 BUS_IO_5 ..............PB25 ( pin 13 ) DATA 1
// 09 BUS_IO_6 ..............PB26 ( pin 14 ) DATA 2
// 10 BUS_IO_7 ..............PB27 ( pin 15 ) DATA 3
// 11 BUS_IO_8 ..............PB28 ( pin 19 ) DATA 4
// 12 BUS_IO_9 ..............PB31 ( pin 22 ) DATA 5
// 13 BUS_IO_10..............PA02 ( pin 30 ) DATA 6
// 14 BUS_IO_11 .............PA04 ( pin 34 ) DATA 7
// 15 VCC_CD
// 16 BACKLIGHT
// 17 NOT USED
// 18 NOT USED
// ...

#define LCD_HD44780_NUM_COLS 40

#define LCD_HD44780_IO_RS  SCOREB_BUS_IO_01
#define LCD_HD44780_IO_RW  SCOREB_BUS_IO_02
#define LCD_HD44780_IO_E   SCOREB_BUS_IO_03
#define LCD_HD44780_IO_D0  SCOREB_BUS_IO_04
#define LCD_HD44780_IO_D1  SCOREB_BUS_IO_05
#define LCD_HD44780_IO_D2  SCOREB_BUS_IO_06
#define LCD_HD44780_IO_D3  SCOREB_BUS_IO_07
#define LCD_HD44780_IO_D4  SCOREB_BUS_IO_08
#define LCD_HD44780_IO_D5  SCOREB_BUS_IO_09
#define LCD_HD44780_IO_D6  SCOREB_BUS_IO_10
#define LCD_HD44780_IO_D7  SCOREB_BUS_IO_11

void LCD_HD44780_init();
void LCD_HD44780_clear();
void LCD_HD44780_write(portCHAR * string_to_write, portCHAR line_numb);
void LCD_HD44780_set_data_byte(portCHAR data_byte);
void LCD_HD44780_send_command_byte();
void LCD_HD44780_send_data_byte();
void LCD_HD44780_write_buffer_to_line(char line_numb);
void LCD_HD44780_clear_buffer();
void LCD_HD44780_set_char_buffer(char character,portSHORT position);
portCHAR LCD_HD44780_get_char_buffer(portSHORT position);
void LCD_HD44780_set_string_buffer(portCHAR * string_to_set);

#endif // SCOREB_LCD_HD44780_H

